Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/include/HierarchyInterface.h
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/include/HierarchyInterface.h	(revision 2306)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/include/HierarchyInterface.h	(revision 2332)
@@ -159,7 +159,9 @@
 	std::vector<HierarchyNode *> *GetVisibleNodes();
 
-	virtual void PullUpLastVisited(GtpVisibility::HierarchyNode *node, const int frameId) const = 0;
-	virtual void DetermineVisibilityRatio(GtpVisibility::HierarchyNode *node) const = 0;
-	virtual float GetNodeVisibilityRatio(GtpVisibility::HierarchyNode *node) const = 0;
+	virtual void PullUpLastVisited(HierarchyNode *node, const int frameId) const = 0;
+	virtual void DetermineVisibilityRatio(HierarchyNode *node) const = 0;
+	virtual float GetNodeVisibilityRatio(HierarchyNode *node) const = 0;
+
+	virtual HierarchyNode *GetParent(HierarchyNode *node) = 0;
 
 protected:
Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/include/CoherentHierarchicalCullingManager.h
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/include/CoherentHierarchicalCullingManager.h	(revision 1492)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/include/CoherentHierarchicalCullingManager.h	(revision 2332)
@@ -30,4 +30,5 @@
 
 protected:
+
 	/** Decides if node is considered to be visible depeding on the 
 		assumed visibility factor.
@@ -36,8 +37,13 @@
 	bool DecideVisible(HierarchyNode *node) const;
 
-
 	/** Skip query for this node.
 	*/
 	void SkipQuery(HierarchyNode *node) const;
+
+	/** If this node is still valid for traversal in this frame.
+		It is possible that the parent was tested invisible before
+		so this node can be skipped.
+	*/
+	bool NodeInvalid(HierarchyNode *node) const;
 
 	/** number of steps the visibility is assumed to be valid.
Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/src/CoherentHierarchicalCullingManager.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/src/CoherentHierarchicalCullingManager.cpp	(revision 2306)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/src/CoherentHierarchicalCullingManager.cpp	(revision 2332)
@@ -33,18 +33,24 @@
 	while (!mHierarchyInterface->GetQueue()->empty() || !queryQueue.empty())
 	{
-		bool resultAvailable = false;
-
+		//////////
 		//-- only wait for result if there are no nodes to process
 		while (!queryQueue.empty() && 
-				queryQueue.front().second->GetQueryResult(visiblePixels, 
-				mHierarchyInterface->GetQueue()->empty()))
+			   (NodeInvalid(queryQueue.front().first) ||
+			    queryQueue.front().second->GetQueryResult(
+				             visiblePixels, mHierarchyInterface->GetQueue()->empty())))
 		{
 			HierarchyNode *node = queryQueue.front().first;
-			
 			queryQueue.pop();
-			
+
+			// parent was tested invisible => remove children from queue
+			if (NodeInvalid(node))
+			{
+				//CullingLogManager::GetSingleton()->LogMessage("skipping this node");
+				continue;
+			}
+			// tested visible
 			if (visiblePixels > mVisibilityThreshold)
 			{
-				// in case geometry is in omterior node: ensure that we only traverse once
+				// in case geometry is in interior node: ensure that we only traverse once
 				if (!mHierarchyInterface->IsNodeVisible(node))
 				{
@@ -58,5 +64,5 @@
 				mHierarchyInterface->SetNodeVisible(node, false);
 
-				++ mNumQueryCulledNodes;
+                ++ mNumQueryCulledNodes;
 				
 				if (mVisualizeCulledNodes)
@@ -65,4 +71,7 @@
 				}
 			}
+			
+			// update node's visited flag
+			mHierarchyInterface->SetLastVisited(node, mHierarchyInterface->GetFrameId());	
 		}
 		
@@ -73,4 +82,11 @@
 			mHierarchyInterface->GetQueue()->pop();
 				
+			// parent was tested invisible => remove children from queue
+			if (NodeInvalid(node))
+			{
+				//CullingLogManager::GetSingleton()->LogMessage("skipping this node");
+				continue;
+			}
+
 			bool intersects = false;
 
@@ -96,6 +112,8 @@
 				
 				// if we assume node to be visible in this frame => skip query 
-				bool skipQuery = wasVisible && (mAssumedVisibility > 0) && 
-					DecideVisible(node) && mHierarchyInterface->HasGeometry(node);
+				const bool skipQuery = wasVisible && 
+					                   (mAssumedVisibility > 0) && 
+									   DecideVisible(node) && 
+									   mHierarchyInterface->HasGeometry(node);
 
 				if (skipQuery)
@@ -113,7 +131,4 @@
 				mHierarchyInterface->SetNodeVisible(node, wasVisible && issueQuery);
 
-				// update node's visited flag
-				mHierarchyInterface->SetLastVisited(node, mHierarchyInterface->GetFrameId());
-				
 				// skip testing previously visible nodes without geometry
 				if (issueQuery)
@@ -124,5 +139,10 @@
 						IssueNodeOcclusionQuery(node, wasVisible)));
 				}
-				
+				else
+				{
+					// update node's visited flag
+					mHierarchyInterface->SetLastVisited(node, mHierarchyInterface->GetFrameId());
+				}
+
 				// always traverse a node if it was visible
 				if (wasVisible)
@@ -164,4 +184,13 @@
 	mHierarchyInterface->TraverseNode(node);
 }
-
+//-----------------------------------------------------------------------
+bool CoherentHierarchicalCullingManager::NodeInvalid(HierarchyNode *node) const
+{
+	// parent was tested invisible in this frame
+	HierarchyNode *parent = mHierarchyInterface->GetParent(node);
+    return 
+		parent && 
+		(mHierarchyInterface->LastVisited(node) == mHierarchyInterface->GetFrameId()) && 
+		!mHierarchyInterface->IsNodeVisible(parent);
+}
 } // namespace GtpVisibility
Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreOctreeHierarchyInterface.h
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreOctreeHierarchyInterface.h	(revision 2306)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreOctreeHierarchyInterface.h	(revision 2332)
@@ -67,4 +67,7 @@
 	float GetNodeVisibilityRatio(GtpVisibility::HierarchyNode *node) const;
 
+	GtpVisibility::HierarchyNode *GetParent(GtpVisibility::HierarchyNode *node);
+
+
 protected:
 
Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgrePlatformHierarchyInterface.h
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgrePlatformHierarchyInterface.h	(revision 2306)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgrePlatformHierarchyInterface.h	(revision 2332)
@@ -130,5 +130,9 @@
 	float GetNodeVisibilityRatio(GtpVisibility::HierarchyNode *node) const { return 1.0f;}
 
+	GtpVisibility::HierarchyNode *GetParent(GtpVisibility::HierarchyNode *node) { return NULL;}
+
+
 protected:
+
 	/** Renders the given geometry 
 	*/
Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/Plugin_VisibilitySceneManager.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/Plugin_VisibilitySceneManager.vcproj	(revision 2318)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/Plugin_VisibilitySceneManager.vcproj	(revision 2332)
@@ -113,5 +113,5 @@
 				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;;&quot;..\..\..\Preprocessing\lib\$(ConfigurationName)&quot;;..\..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\Preprocessing\src\GL;..\..\..\..\..\..\..\NonGTP\Zlib\lib;&quot;..\..\lib\$(ConfigurationName)&quot;;&quot;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\lib\$(ConfigurationName)&quot;;&quot;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\ObjReader\lib\$(ConfigurationName)&quot;"
 				ModuleDefinitionFile="..\misc\OgreVisibilitySceneManager.def"
-				GenerateDebugInformation="TRUE"
+				GenerateDebugInformation="FALSE"
 				SubSystem="2"
 				OptimizeReferences="2"
@@ -371,5 +371,5 @@
 				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include&quot;;..\include;..\..\..\OnlineCullingCHC\include;..\..\..\Preprocessing\src;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\include"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;PLUGIN_KD_TERRAIN_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;PLUGIN_KD_TERRAIN_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="TRUE"
 				RuntimeLibrary="2"
Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOctreeHierarchyInterface.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOctreeHierarchyInterface.cpp	(revision 2306)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOctreeHierarchyInterface.cpp	(revision 2332)
@@ -188,5 +188,5 @@
 //-----------------------------------------------------------------------
 void OctreeHierarchyInterface::DetermineVisibilityRatio(GtpVisibility::HierarchyNode *node) const
-{		
+{	
 	Octree *octant = static_cast<Octree *>(node);
 
@@ -394,4 +394,11 @@
 }
 
+//-----------------------------------------------------------------------
+GtpVisibility::HierarchyNode *OctreeHierarchyInterface::GetParent(GtpVisibility::HierarchyNode *node)
+{
+	Octree *octree = static_cast<Octree *>(node);
+
+	return octree->getParent();
+}
 
 } // namespace Ogre
Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/include/ObjReader.h
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/include/ObjReader.h	(revision 2124)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/include/ObjReader.h	(revision 2332)
@@ -21,7 +21,5 @@
 				  const std::string &visibilitySolution,
 				  Ogre::SceneNode *root);
-	void dummy();
-	Ogre::Entity * dummy2(const std::string &name,
-				GtpVisibilityPreprocessor::Intersectable *object);
+	
 	Ogre::Entity *CreateEntity(const std::string &name,
 							   GtpVisibilityPreprocessor::Intersectable *object);
Index: /GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjReader.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjReader.vcproj	(revision 2318)
+++ /GTP/trunk/Lib/Vis/OnlineCullingCHC/ObjReader/src/ObjReader.vcproj	(revision 2332)
@@ -295,5 +295,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;..\include"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;..\include;..\..\..\Preprocessing\src"
 				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;OBJREADER_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
 				RuntimeLibrary="2"
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj	(revision 2288)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj	(revision 2332)
@@ -38,5 +38,5 @@
 				LinkIncremental="2"
 				AdditionalLibraryDirectories="..\include;..\src\GL;&quot;..\lib\$(ConfigurationName)&quot;;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib"
-				GenerateDebugInformation="TRUE"
+				GenerateDebugInformation="FALSE"
 				ProgramDatabaseFile="$(OutDir)/TestPreprocessor.pdb"
 				SubSystem="1"
@@ -126,60 +126,4 @@
 		</Configuration>
 		<Configuration
-			Name="mlrt|Win32"
-			OutputDirectory="$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
-			ConfigurationType="1"
-			CharacterSet="2">
-			<Tool
-				Name="VCCLCompilerTool"
-				Optimization="2"
-				GlobalOptimizations="FALSE"
-				FavorSizeOrSpeed="1"
-				OptimizeForProcessor="3"
-				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\MultiLevelRayTracing"
-				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL"
-				MinimalRebuild="TRUE"
-				RuntimeLibrary="2"
-				RuntimeTypeInfo="TRUE"
-				UsePrecompiledHeader="0"
-				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLinkerTool"
-				AdditionalDependencies="xerces-c_2.lib glew32.lib zdll.lib zziplib.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib cg.lib cgGL.lib Preprocessor.lib RTWorld.lib RTScene.lib"
-				OutputFile="$(OutDir)/Preprocessor.exe"
-				LinkIncremental="1"
-				AdditionalLibraryDirectories="..\src\mlrt;&quot;$(CG_LIB_PATH)&quot;;..\src\GL;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\..\Preprocessing\MultiLevelRayTracing\RTScene\Release;..\..\Preprocessing\MultiLevelRayTracing\RTWorld\Release"
-				GenerateDebugInformation="FALSE"
-				SubSystem="1"
-				OptimizeReferences="2"
-				EnableCOMDATFolding="2"
-				TargetMachine="1"
-				FixedBaseAddress="1"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCWebDeploymentTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
-		</Configuration>
-		<Configuration
 			Name="Release Internal|Win32"
 			OutputDirectory="..\bin\Release"
@@ -201,5 +145,5 @@
 				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;QtInterface;..\src\sparsehash\src\;..\src\ootl\src\include\ootl;..\src\ootl\src\include\ootl\sandbox;$(NOINHERIT)"
-				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;USE_QT;USE_CG;USE_HASH_PV;USE_SSE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;USE_QT;USE_CG;USE_HASH_PV"
 				StringPooling="TRUE"
 				MinimalRebuild="TRUE"
@@ -269,5 +213,5 @@
 				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;"
-				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;NO_QT"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;NO_QT;USE_SSE"
 				RuntimeLibrary="2"
 				EnableEnhancedInstructionSet="2"
@@ -285,5 +229,5 @@
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="..\src\GL;..\lib\release;..\..\Preprocessing\lib\release;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\MultiLevelRayTracing\RTScene\Release;..\MultiLevelRayTracing\RTWorld\Release"
-				GenerateDebugInformation="FALSE"
+				GenerateDebugInformation="TRUE"
 				SubSystem="1"
 				OptimizeReferences="2"
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 2232)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 2332)
@@ -8,4 +8,5 @@
 #include "ViewCell.h"
 
+#define TEST_PACKETS 0
 
 namespace GtpVisibilityPreprocessor {
@@ -162,8 +163,8 @@
 		@param storeViewCells true if view cells should be stored in the ray
 	*/
-	float ComputeSampleContributions(const VssRayContainer &rays,
-									 const bool addContributions,
-									 const bool storeViewCells,
-									 const bool useHitObject = false);
+	virtual float ComputeSampleContributions(const VssRayContainer &rays,
+		                                     const bool addContributions,
+											 const bool storeViewCells,
+											 const bool useHitObject = false);
 
 	/** Computes sample contribution of a simgle ray to the view cells PVS.
@@ -495,8 +496,6 @@
 										 ViewCellContainer &viewCells);
 
-	/** Evaluates the render cost of a view cell.
-	*/
-	static float EvalRenderCost(Intersectable *obj);
-   
+	float ComputeRenderCost(const int tri, const int obj); //const
+
 	/** Sets pvs size of view cell as a scalar. Used when storing pvs only in the leaves
 		of the hierarchy.
@@ -906,7 +905,9 @@
 	bool mUsePredefinedViewCells;
 
-  
-  vector<PerViewCellStat> mPerViewCellStat;
-  SamplesStatistics mSamplesStat;
+	float mTriangleWeight;
+	float mObjectWeight;
+
+	vector<PerViewCellStat> mPerViewCellStat;
+	SamplesStatistics mSamplesStat;
 };
 
@@ -1299,4 +1300,15 @@
 	virtual void FinalizeViewCells(const bool createMesh);
 
+#if TEST_PACKETS
+#ifdef USE_SSE
+
+	float ViewCellsManager::ComputeSampleContributions(const VssRayContainer &rays,
+		                                               const bool addContributions,
+													   const bool storeViewCells,
+													   const bool useHitObjects);
+
+#endif
+#endif
+
 protected:
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ObjectPvs.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ObjectPvs.cpp	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ObjectPvs.cpp	(revision 2332)
@@ -91,5 +91,5 @@
 
 		leaf->Mail();
-		return BvHierarchy::EvalAbsCost(leaf->mObjects);
+		return (float)leaf->mObjects.size();
 	}			 
 
@@ -114,5 +114,5 @@
 
 				// add #objects exclusivly in this node
-				pvs += BvHierarchy::EvalAbsCost(leaf->mObjects);
+				pvs += (float)leaf->mObjects.size();
 			}
 			else // traverse tree
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 2228)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 2332)
@@ -1532,4 +1532,14 @@
 					"0.1");
 
+	RegisterOption("ViewCells.triangleWeight",
+					optFloat,
+					"view_cells_triangle_weight=",
+					"1.0");
+
+	RegisterOption("ViewCells.objectWeight",
+					optFloat,
+					"view_cells_object_weight=",
+					"0.0");
+
 	RegisterOption("ViewCells.filename",
 					optString,
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 2288)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 2332)
@@ -106,56 +106,5 @@
 				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
 		</Configuration>
-		<Configuration
-			Name="mlrt|Win32"
-			OutputDirectory="$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
-			ConfigurationType="4"
-			CharacterSet="2">
-			<Tool
-				Name="VCCLCompilerTool"
-				Optimization="2"
-				GlobalOptimizations="FALSE"
-				InlineFunctionExpansion="0"
-				EnableIntrinsicFunctions="FALSE"
-				FavorSizeOrSpeed="1"
-				OmitFramePointers="FALSE"
-				EnableFiberSafeOptimizations="FALSE"
-				OptimizeForProcessor="3"
-				OptimizeForWindowsApplication="TRUE"
-				AdditionalIncludeDirectories="..\include;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\..\Preprocessing\MultiLevelRayTracing"
-				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL"
-				MinimalRebuild="TRUE"
-				ExceptionHandling="TRUE"
-				RuntimeLibrary="2"
-				DisableLanguageExtensions="FALSE"
-				ForceConformanceInForLoopScope="FALSE"
-				RuntimeTypeInfo="TRUE"
-				UsePrecompiledHeader="0"
-				WarningLevel="2"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLibrarianTool"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
-		</Configuration>
+	
 		<Configuration
 			Name="Release_Internal|Win32"
@@ -224,5 +173,5 @@
 				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(CG_INC_PATH)&quot;;Timer;..\src\sparsehash\src\google\sparsehash;..\src\sparsehash\src\windows;..\src\sparsehash\src\google;..\src\sparsehash\src;..\src\ootl\;..\src\ootl\src\;..\src\ootl\src\cpp;..\src\ootl\src\cpp\include\;..\src\ootl\src\include\ootl;..\src\ootl\src\include\ootl\sandbox;..\src\ootl\src\cpp\include\ootl\mswin"
-				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;USE_QT;USE_HASH_PV;USE_SSE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;USE_QT;USE_HASH_PV"
 				StringPooling="TRUE"
 				MinimalRebuild="TRUE"
@@ -268,5 +217,5 @@
 			ConfigurationType="4"
 			CharacterSet="2"
-			WholeProgramOptimization="FALSE">
+			WholeProgramOptimization="TRUE">
 			<Tool
 				Name="VCCLCompilerTool"
@@ -282,6 +231,6 @@
 				OptimizeForProcessor="1"
 				OptimizeForWindowsApplication="TRUE"
-				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;"
-				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;NO_QT"
+				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;NO_QT;USE_SSE"
 				StringPooling="TRUE"
 				MinimalRebuild="TRUE"
@@ -688,12 +637,5 @@
 						Outputs=""/>
 				</FileConfiguration>
-				<FileConfiguration
-					Name="mlrt|Win32">
-					<Tool
-						Name="VCCustomBuildTool"
-						Description=""
-						CommandLine=""
-						Outputs=""/>
-				</FileConfiguration>
+			
 				<FileConfiguration
 					Name="Release_Internal|Win32">
@@ -748,12 +690,5 @@
 						Outputs=""/>
 				</FileConfiguration>
-				<FileConfiguration
-					Name="mlrt|Win32">
-					<Tool
-						Name="VCCustomBuildTool"
-						Description=""
-						CommandLine=""
-						Outputs=""/>
-				</FileConfiguration>
+				
 				<FileConfiguration
 					Name="Release_Internal|Win32">
@@ -1174,8 +1109,8 @@
 			</File>
 			<File
+				RelativePath=".\sparsehash\src\google\sparsehash\hash_fun.h">
+			</File>
+			<File
 				RelativePath=".\sparsehash\src\windows\hash_fun.h">
-			</File>
-			<File
-				RelativePath=".\sparsehash\src\google\sparsehash\hash_fun.h">
 			</File>
 			<File
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.h	(revision 2237)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.h	(revision 2332)
@@ -294,9 +294,5 @@
 	inline bool ConsiderMemory() const { return mConsiderMemory; }
 	
-	void EvaluateSubdivision(const VssRayContainer &sampleRays,											 
-							 const ObjectContainer &objects,
-							 const std::string &filename);
-
-	void EvaluateSubdivision2(std::ofstream &splitsStats,
+	void EvaluateSubdivision(std::ofstream &splitsStats,
 							  const int splitsStepSize,
 							  const bool useFilter,
@@ -409,7 +405,7 @@
 								SubdivisionCandidateContainer &dirtyList);
 
-	/** Evaluate subdivision stats for log.
-	*/
-	void EvalSubdivisionStats();
+	/** Print subdivision stats for log.
+	*/
+	void PrintSubdivisionStats();
 
 	void AddSubdivisionStats(const int splits,
@@ -563,5 +559,5 @@
 						  bool &histoUsed);
 
-	void ComputePvs(const ObjectPvs &pvs, float &rc, int &pvsEntries);
+	void ComputePvs(const ObjectPvs &pvs, float &triangles, int &pvsEntries);
 	void GetPvsIncrementially(ViewCell *vc, ObjectPvs &pvs) const;
 	void PullUpPvsIncrementally(ViewCell *viewCell) const;
@@ -571,4 +567,5 @@
 	float EvalFullMem() const;
 
+	ViewCellsManager *GetViewCellsManager();
 
 protected:
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VssPreprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VssPreprocessor.cpp	(revision 2283)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VssPreprocessor.cpp	(revision 2332)
@@ -463,9 +463,4 @@
 				"#AvgRayContrib\n" << avgRayContrib << endl;
 		}
-
-		cout << "#totalPvsSize=" << mKdTree->CollectLeafPvs() << endl;
-
-
-
 	}
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.h	(revision 2288)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.h	(revision 2332)
@@ -45,5 +45,4 @@
 
 
-#define WORK_WITH_VIEWCELLS 0
 
 /** View space partition statistics.
@@ -573,4 +572,7 @@
 		float mBackPvs;
 
+		float mFrontTriangles;
+		float mBackTriangles;
+		
 		float mCorrectedFrontRenderCost;
 		float mCorrectedBackRenderCost;
@@ -733,16 +735,4 @@
 	void SetViewCellsTree(ViewCellsTree *vt) { mViewCellsTree = vt; }
 
-#if WORK_WITH_VIEWCELLS
-	/** Remove the references of the parent view cell from the kd nodes associated with
-		the objects.
-	*/
-	void RemoveParentViewCellReferences(ViewCell *parent) const;
-
-	/** Adds references to the view cell to the kd nodes associated with the objects.
-	*/
-	void AddViewCellReferences(ViewCell *vc) const;
-#endif
-
-	VspNode *SubdivideAndCopy(SplitQueue &tQueue, SubdivisionCandidate *splitCandidate);
 
 	PerfTimer mSortTimer;
@@ -1075,5 +1065,8 @@
 								ViewCell *back) const;
 
-	void CreateViewCell(VspTraversalData &tData, const bool updatePvs);
+	void CreateViewCell(VspTraversalData &tData, 
+						const bool updatePvs,
+						const float renderCost,
+						const int pvs);
 
 	/** Collect split candidates which are affected by the last split
@@ -1113,11 +1106,10 @@
 	*/
 	void Initialise(const VssRayContainer &rays,
-					AxisAlignedBox3 *forcedBoundingBox);
+					AxisAlignedBox3 *forcedBoundingBox,
+					const ObjectContainer &objects);
 
 	int CompressObjects();
 
 	int CompressObjects(VspLeaf *leaf);
-
-	void TraverseRayPacket();
 
 #ifdef USE_SSE
@@ -1125,11 +1117,42 @@
 	struct RayPacket
 	{
-		union { float ox[4]; __m128 ox4; };
-		union { float oy[4]; __m128 oy4; };
-		union { float oz[4]; __m128 oz4; };
-		union { float dx[4]; __m128 dx4; };
-		union { float dy[4]; __m128 dy4; };
-		union { float dz[4]; __m128 dz4; };
+		union { float mOriginX[4]; __m128 mOriginX4; };
+		union { float mOriginY[4]; __m128 mOriginY4; };
+		union { float mOriginZ[4]; __m128 mOriginZ4; };
+
+		union { float mTerminationX[4]; __m128 mTerminationX4; };
+		union { float mTerminationY[4]; __m128 mTerminationY4; };
+		union { float mTerminationZ[4]; __m128 mTerminationZ4; };
+
+		ViewCellContainer mViewCells[4];
 	};
+
+	struct PacketTraversalData
+	{
+		VspNode *mNode;
+
+		union { float mExitPointX[4]; __m128 mExitPointX4; };
+		union { float mExitPointY[4]; __m128 mExitPointY4; };
+		union { float mExitPointZ[4]; __m128 mExitPointZ4; };
+
+		union { float mMaxT[4]; __m128 mMaxT4; };
+		union { float mMask[4]; __m128 mMask4; };
+
+		PacketTraversalData () {}
+		PacketTraversalData (VspNode *n, 
+							 const __m128 &px, const __m128 &py, const __m128 &pz, 
+							 const __m128 &maxt,
+							 const __m128 &mask):
+		mNode(n), 
+		mExitPointX4(px), mExitPointY4(py), mExitPointZ4(pz),
+		mMaxT4(maxt),
+		mMask4(mask)
+		{}
+	};
+
+	
+	int TraverseRayPacket(RayPacket &rp,
+						  const bool useMailboxing);
+
 #endif
 
@@ -1141,7 +1164,4 @@
 	HierarchyManager *mHierarchyManager;
 	BvHierarchy *mBvHierarchy;
-
-	//OspTree *mOspTree;
-	//bool mUseKdPvsForHeuristics;
 	
 	ViewCellsManager *mViewCellsManager;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Trackball.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Trackball.cpp	(revision 1743)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Trackball.cpp	(revision 2332)
@@ -193,7 +193,7 @@
      * Avoid problems with out-of-control values...
      */
-    if (t > 1.0) t = 1.0;
-    if (t < -1.0) t = -1.0;
-    phi = 2.0 * asin(t);
+    if (t > 1.0f) t = 1.0f;
+    if (t < -1.0f) t = -1.0f;
+    phi = 2.0f * asin(t);
 
     axis_to_quat(a,phi,q);
